Index: main/plugin-core/src/org/ametys/core/datasource/sql/SQLDataSourceManager.java
===================================================================
--- main/plugin-core/src/org/ametys/core/datasource/sql/SQLDataSourceManager.java	(revision 0)
+++ main/plugin-core/src/org/ametys/core/datasource/sql/SQLDataSourceManager.java	(revision 0)
@@ -0,0 +1,556 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.core.datasource.sql;
+
+import java.io.File;
+import java.io.FileInputStream;
+import java.io.FileOutputStream;
+import java.io.InputStream;
+import java.io.OutputStream;
+import java.sql.Connection;
+import java.sql.SQLException;
+import java.util.HashMap;
+import java.util.Map;
+import java.util.Properties;
+import java.util.Set;
+
+import javax.sql.DataSource;
+import javax.xml.transform.OutputKeys;
+import javax.xml.transform.TransformerFactory;
+import javax.xml.transform.TransformerFactoryConfigurationError;
+import javax.xml.transform.sax.SAXTransformerFactory;
+import javax.xml.transform.sax.TransformerHandler;
+import javax.xml.transform.stream.StreamResult;
+
+import org.apache.avalon.framework.activity.Disposable;
+import org.apache.avalon.framework.activity.Initializable;
+import org.apache.avalon.framework.component.Component;
+import org.apache.avalon.framework.configuration.Configuration;
+import org.apache.avalon.framework.configuration.DefaultConfigurationBuilder;
+import org.apache.cocoon.ProcessingException;
+import org.apache.cocoon.xml.XMLUtils;
+import org.apache.commons.dbcp2.ConnectionFactory;
+import org.apache.commons.dbcp2.DriverManagerConnectionFactory;
+import org.apache.commons.dbcp2.PoolableConnection;
+import org.apache.commons.dbcp2.PoolableConnectionFactory;
+import org.apache.commons.dbcp2.PoolingDataSource;
+import org.apache.commons.pool2.ObjectPool;
+import org.apache.commons.pool2.impl.GenericObjectPool;
+import org.xml.sax.helpers.AttributesImpl;
+
+import org.ametys.core.util.StringUtils;
+import org.ametys.plugins.core.impl.checker.SQLConnectionChecker;
+import org.ametys.runtime.config.Config;
+import org.ametys.runtime.config.ConfigManager;
+import org.ametys.runtime.i18n.I18nizableText;
+import org.ametys.runtime.parameter.ParameterChecker;
+import org.ametys.runtime.parameter.ParameterHelper.ParameterType;
+import org.ametys.runtime.plugin.PluginsManager;
+import org.ametys.runtime.plugin.component.AbstractLogEnabled;
+import org.ametys.runtime.servlet.RuntimeConfig;
+
+/**
+ * Avalon component handling the SQL data sources. It manages the file $AMETYS_HOME/datasources-sql.xml 
+ */
+public class SQLDataSourceManager extends AbstractLogEnabled implements Component, Disposable, Initializable
+{
+    /** Avalon Role */
+    public static final String ROLE = SQLDataSourceManager.class.getName();
+    
+    /** The id of the default data source */
+    private static final String __DEFAULT_DATASOURCE_ID = "SQL-derby-internal";
+    
+    /** The key for the name of the default data source */
+    private static final I18nizableText __DEFAULT_DATASOURCE_NAME = new I18nizableText("plugin.core", "PLUGINS_CORE_DEFAULT_DATASOURCE_LABEL");
+    
+    /** The key for the description of the default data source */
+    private static final I18nizableText __DEFAULT_DATASOURCE_DESCRIPTION = new I18nizableText("plugin.core", "PLUGINS_CORE_DEFAULT_DATASOURCE_DESCRIPTION");
+
+    /** The driver of the default data source */
+    private static final String __DEFAULT_DATASOURCE_DRIVER = "org.apache.derby.jdbc.EmbeddedDriver";
+    
+    /** The path of the file to use */
+    private static String _sqlDataSourcesFilePath;
+
+    /** The map representation of the datasources-sql.xml file */
+    private Map<String, Map<String, Object>> _dataSourcesDescriptions;
+    
+    /** The mapping of the datasources with their ids */
+    private Map<String, DataSource> _dataSources;
+    
+    /** The connection pools */
+    private Map<String, ObjectPool> _pools = new HashMap<>();
+    
+    /**
+     * Set the name of the file that will be read by the manager
+     * @param fileName the name of the file
+     */
+    public static void setFilename(String fileName)
+    {
+        _sqlDataSourcesFilePath = fileName;
+    }
+    
+    @Override
+    public void dispose()
+    {
+        for (String id : _pools.keySet())
+        {
+            _dispose(id);
+        }
+    }
+
+    @Override
+    public void initialize() throws Exception
+    {
+        _dataSources = new HashMap<>();
+        _dataSourcesDescriptions = new HashMap<> ();
+        
+        File sqlDatasourcesFile = new File(_sqlDataSourcesFilePath);
+        if (!sqlDatasourcesFile.exists())
+        {
+            sqlDatasourcesFile.getParentFile().mkdirs();
+            sqlDatasourcesFile.createNewFile();
+        }
+        
+        // Initialize the default SQL data source
+        String defaultDataSourceURL = "jdbc:derby:" + RuntimeConfig.getInstance().getAmetysHome() + "/internal-db;create=true";
+        _initializeDataSource(__DEFAULT_DATASOURCE_ID, "", "", __DEFAULT_DATASOURCE_DRIVER, defaultDataSourceURL, null, null, false);
+        
+        if (sqlDatasourcesFile.length() != 0)
+        {
+            Configuration configuration;
+            try (InputStream is = new FileInputStream(sqlDatasourcesFile))
+            {
+                configuration = new DefaultConfigurationBuilder().build(is);
+            }
+            
+            // Initialize the connection pools
+            for (Configuration datasourceConfiguration : configuration.getChildren("datasource"))
+            {
+                String id = datasourceConfiguration.getAttribute("id");
+                
+                String driver = datasourceConfiguration.getChild("driver").getValue();
+                String url = datasourceConfiguration.getChild("url").getValue();
+                String user = datasourceConfiguration.getChild("user").getValue("");
+                String password = datasourceConfiguration.getChild("password").getValue("");
+
+                // Validate the used SQL data sources if not already in safe mode
+                if (isInUse(id) && !PluginsManager.getInstance().isSafeMode())
+                {
+                    Map<String, String> testParameters = new HashMap<> ();
+                    testParameters.put("driver", driver);
+                    testParameters.put("url", url);
+                    testParameters.put("user", user);
+                    testParameters.put("password", password);
+                    
+                    ParameterChecker paramChecker = new SQLConnectionChecker();
+                    try
+                    {
+                        paramChecker.check(testParameters);
+                    }
+                    catch (Throwable t)
+                    {
+                        throw new IllegalArgumentException("The SQL data source of id '" + id + "' is not valid", t);
+                    } 
+                }
+                
+                String name = datasourceConfiguration.getChild("name").getValue();
+                String description = datasourceConfiguration.getChild("description").getValue("");
+                String isPrivate = datasourceConfiguration.getChild("private").getValue("");
+                
+                _initializeDataSource(id, name, description, driver, url, user, password, isPrivate.equals("true"));
+            }
+        }
+    }
+
+    /**
+     * Get the id of the default data source
+     * @return the id of the default data source
+     */
+    public String getDefaultDataSourceId()
+    {
+        return __DEFAULT_DATASOURCE_ID;
+    }
+    
+    /**
+     * Get the i18n key for the default data source name
+     * @return the i18n key for the default data source name
+     */
+    public I18nizableText getDefaultDataSourceName()
+    {
+        return __DEFAULT_DATASOURCE_NAME;
+    }
+    
+    /**
+     * Get the i18n key for the default data source description
+     * @return the i18n key for the default data source description
+     */
+    public I18nizableText getDefaultDataSourceDescription()
+    {
+        return __DEFAULT_DATASOURCE_DESCRIPTION;
+    }
+    
+    /**
+     * Get the existing SQL data sources
+     * @return the SQL data sources
+     */
+    public Map<String, DataSource> getSQLDataSources ()
+    {
+        return _dataSources;
+    }
+    
+    /**
+     * Get the SQL data source by its identifier
+     * @param id The id of data source
+     * @return the SQL data source
+     */
+    public DataSource getSQLDataSource (String id)
+    {
+        return _dataSources.get(id);
+    }
+    
+    /**
+     * Get the parameters of a SQL data source (label, driver, url, login, password) 
+     * @param id the id of the wanted data source
+     * @return the data source's parameters values
+     * @throws Exception if an exception occurred when retrieving the sql data source parameters
+     */
+    public Map<String, Object> getSQLDataSourceDescription (String id) throws Exception
+    {
+        return _dataSourcesDescriptions.get(id);
+    }
+    
+    /**
+     * Get the existing SQL data sources as JSON 
+     * @return the SQL data sources JSON representation
+     */
+    public Map<String, Map<String, Object>> getSQLDataSourcesDescriptions ()
+    {
+        return _dataSourcesDescriptions;
+    }
+    
+    /**
+     * Determines if a data source is in use by a configuration parameter
+     * @param id The id of data source to check
+     * @return true if the data source is in use
+     */
+    public boolean isInUse (String id)
+    {
+        Config config = Config.getInstance();
+        if (config != null)
+        {
+            for (String dataSourceId : ConfigManager.getInstance().getIdsByType(ParameterType.DATASOURCE))
+            {
+                String dataSourceValue = config.getValueAsString(dataSourceId);
+                if (dataSourceValue != null && dataSourceValue.equals(id))
+                {
+                    return true;
+                }
+            }
+        }
+        
+        return false;
+    }
+    
+    /**
+     * Returns a Connection from the pool.
+     * @param poolId the id of the connection pool
+     * @return a java.sql.Connection to query a SQL database
+     */
+    public Connection getConnection(String poolId)
+    {
+        DataSource dataSource;
+        Connection connection = null;
+
+        try
+        {
+            dataSource =  getSQLDataSource(poolId);
+            connection = dataSource.getConnection();
+        }
+        catch (SQLException e)
+        {
+            throw new RuntimeException("Unable to get Connection from pool " + poolId, e);
+        }
+
+        return connection;
+    }
+    
+    /**
+     * Save a single data source
+     * @param parameters The parameters of the data source
+     * @throws Exception if an error occurs during the saving process
+     * @return the id of the created/edited data source 
+     */
+    public String saveSQLDataSource (Map<String, Object> parameters) throws Exception
+    {
+        String id = (String) parameters.get("id");
+        if (!_dataSourcesDescriptions.containsKey(id))
+        {
+            id = _addSQLDataSource(parameters);
+        }
+        else
+        {
+            if (parameters.get("password") == null)
+            {
+                // Get the recorded password : null password => saved password
+                parameters.put("password", _dataSourcesDescriptions.get(id).get("password"));
+            }
+            
+            _editSQLDataSource(parameters);
+        }
+        
+        // Update the stored data
+        _createAndSavePool((String) parameters.get("id"), (String) parameters.get("driver"), (String) parameters.get("url"), (String) parameters.get("user"), (String) parameters.get("password"));
+        
+        // Save changes in the file
+        _save();
+        
+        return id;
+    }
+    
+    /**
+     * Delete a data source with its id
+     * @param id The id of the data source to delete
+     * @throws Exception if an error occurs during the saving process 
+     */
+    public void removeSQLDataSource (String id) throws Exception
+    {
+        _deleteSQLDataSource(id);
+        _save();
+    }
+    
+    /**
+     * Add a SQL data source
+     * @param parameters the parameters of the new data source
+     * @return the id of the created data source 
+     */
+    private String _addSQLDataSource(Map<String, Object> parameters)
+    {
+        String id = "SQL-" + StringUtils.generateKey();
+        _dataSourcesDescriptions.put(id, parameters);
+
+        return id;
+    }
+
+    /**
+     * Edit a SQL data source
+     * @param parameters the parameters of the data source to edit
+     */
+    private void _editSQLDataSource(Map<String, Object> parameters)
+    {
+        String id = (String) parameters.get("id");
+        _dataSourcesDescriptions.put(id, parameters);
+    }
+    
+    /**
+     * Initialize a data source 
+     * @param id the id of the data source
+     * @param name the name of the data source
+     * @param description the description of the data source
+     * @param driver the driver of the data source
+     * @param url the url of the data source
+     * @param user the user. can be null
+     * @param password the password. can be null
+     * @param isPrivate is this data source private ?
+     */
+    private void _initializeDataSource(String id, String name, String description, String driver, String url, String user, String password, boolean isPrivate)
+    {
+        _createAndSavePool(id, driver, url, user, password);
+        
+        // Keep a map representation of the XML file to limit the read access
+        Map<String, Object> parameters = new HashMap<> ();
+        parameters.put("name", name);
+        parameters.put("description", description);
+        parameters.put("driver", driver);
+        parameters.put("url", url);
+        parameters.put("user", user);
+        parameters.put("password", password);
+        parameters.put("private", isPrivate);
+        
+        _dataSourcesDescriptions.put(id, parameters);
+    }
+    
+    /**
+     * Create and store the pools/data sources
+     * @param id the id of the data source
+     * @param driver the driver used by the data source 
+     * @param url the url where to find the data source
+     * @param user the login
+     * @param password the corresponding password
+     */
+    private void _createAndSavePool(String id, String driver, String url, String user, String password)
+    {
+        ConnectionFactory connectionFactory = new DriverManagerConnectionFactory(url, user, password);
+        PoolableConnectionFactory poolableConnectionFactory = new PoolableConnectionFactory(connectionFactory, null);
+        
+        GenericObjectPool<PoolableConnection> connectionPool = new GenericObjectPool<>(poolableConnectionFactory);
+        connectionPool.setMaxTotal(-1);
+        connectionPool.setMaxIdle(10);
+        connectionPool.setMinIdle(2);
+        connectionPool.setTestOnBorrow(true);
+        connectionPool.setTestOnReturn(false);
+        connectionPool.setTestWhileIdle(true);
+        connectionPool.setTimeBetweenEvictionRunsMillis(1000 * 60 * 30);
+        
+        poolableConnectionFactory.setPool(connectionPool);
+        poolableConnectionFactory.setValidationQuery(_getValidationQuery(driver));
+        poolableConnectionFactory.setDefaultAutoCommit(true);
+        poolableConnectionFactory.setDefaultReadOnly(false);
+                 
+        PoolingDataSource<PoolableConnection> dataSource = new PoolingDataSource<>(connectionPool);
+        
+        // make sure the previous connection has been disposed
+        if (_pools.containsKey(id))
+        {
+            _dispose(id);
+        }
+        
+        // Store the connection pools and the data sources
+        _pools.put(id, connectionPool);
+        _dataSources.put(id, dataSource);
+    }
+    
+    /**
+     * Delete a SQL data source
+     * @param id the id of the data source to delete
+     */
+    private void _deleteSQLDataSource(String id)
+    {
+        _dataSourcesDescriptions.remove(id);
+        _dataSources.remove(id);
+        
+        // Dispose of the corresponding connection before removing it
+        _dispose(id);
+    }
+    
+    /**
+     * Save the SQL data sources in the datasources-sql.xml file
+     * @throws TransformerFactoryConfigurationError if an error occurs while configuring the transformer factory
+     * @throws ProcessingException if an error occurs during the saving process
+     */
+    private void _save() throws TransformerFactoryConfigurationError, ProcessingException
+    {
+        File sqlDatasourcesFile = new File(RuntimeConfig.getInstance().getAmetysHome() + "/datasources-sql.xml");
+        try
+        {
+            // Create file if it doest not already exist
+            if (!sqlDatasourcesFile.exists())
+            {
+                sqlDatasourcesFile.getParentFile().mkdirs();
+                sqlDatasourcesFile.createNewFile();
+            }
+            
+            // create a transformer for saving sax into a file
+            TransformerHandler th = ((SAXTransformerFactory) TransformerFactory.newInstance()).newTransformerHandler();
+
+            // create the result where to write
+            try (OutputStream os = new FileOutputStream(sqlDatasourcesFile))
+            {
+                StreamResult sResult = new StreamResult(os);
+                th.setResult(sResult);
+    
+                // create the format of result
+                Properties format = new Properties();
+                format.put(OutputKeys.METHOD, "xml");
+                format.put(OutputKeys.INDENT, "yes");
+                format.put(OutputKeys.ENCODING, "UTF-8");
+                th.getTransformer().setOutputProperties(format);
+    
+                // Send SAX events
+                th.startDocument();
+                XMLUtils.startElement(th, "datasources");
+                
+                AttributesImpl idAttr = new AttributesImpl();
+                
+                // Do not save the default data source in the file
+                Set<String> dataSourceDescriptionKeys = _dataSourcesDescriptions.keySet();
+                for (String id : dataSourceDescriptionKeys)
+                {
+                    if (id != __DEFAULT_DATASOURCE_ID)
+                    {
+                        Map<String, Object> datasourceParameters = _dataSourcesDescriptions.get(id);
+                        
+                        idAttr.addAttribute("", "id", "id", "CDATA", id);
+                        XMLUtils.startElement(th, "datasource", idAttr);
+                        XMLUtils.createElement(th, "name", (String) datasourceParameters.get("name"));
+                        XMLUtils.createElement(th, "description", (String) datasourceParameters.get("description"));
+                        XMLUtils.createElement(th, "driver", (String) datasourceParameters.get("driver"));
+                        XMLUtils.createElement(th, "url", (String) datasourceParameters.get("url"));
+                        XMLUtils.createElement(th, "user", (String) datasourceParameters.get("user"));
+                        
+                        String password = (String) datasourceParameters.get("password");
+                        XMLUtils.createElement(th, "password", password != null ? password : "");
+                        
+                        String isPrivate = (Boolean) datasourceParameters.get("private") ? "true" : "false";
+                        XMLUtils.createElement(th, "private", isPrivate);
+                        XMLUtils.endElement(th, "datasource");
+                        idAttr.clear();
+                    }
+                }
+                
+                XMLUtils.endElement(th, "datasources");
+                th.endDocument();
+            }
+        }
+        catch (Exception e)
+        {
+            throw new ProcessingException("Unable to save the sql data sources values", e);
+        }
+    }
+    
+    /**
+     * Get the appropriate validation query
+     * @param driver the driver 
+     * @return the validation query
+     */
+    private String _getValidationQuery(String driver)
+    {
+        if ("oracle.jdbc.driver.OracleDriver".equals(driver) || "oracle.jdbc.OracleDriver".equals(driver))
+        {
+            return "SELECT 1 FROM DUAL";
+        }
+        else if ("org.apache.derby.jdbc.EmbeddedDriver".equals(driver))
+        {
+            return "SELECT 1 FROM SYS.SYSTABLES";
+        }
+        else if ("org.hsqldb.jdbcDriver".equals(driver) || "org.hsqldb.jdbc.JDBCDriver".equals(driver))
+        {
+            return "SELECT 1 FROM INFORMATION_SCHEMA.SYSTEM_USERS";
+        }
+        else
+        {
+            return "SELECT 1";
+        }
+    }
+    
+    /**
+     * Dispose of a connection pool
+     * @param id the id of the connection pool to dispose of
+     */
+    private void _dispose(String id)
+    {
+        try
+        {
+            _pools.get(id).close();
+        }
+        catch (Exception e)
+        {
+            getLogger().warn("Unable to close the edited connection pool", e);
+        }        
+        
+        _pools.remove(id);
+    }
+}
Index: main/plugin-core/src/org/ametys/core/datasource/sql/dbtype/SQLDatabaseType.java
===================================================================
--- main/plugin-core/src/org/ametys/core/datasource/sql/dbtype/SQLDatabaseType.java	(revision 0)
+++ main/plugin-core/src/org/ametys/core/datasource/sql/dbtype/SQLDatabaseType.java	(revision 0)
@@ -0,0 +1,55 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.core.datasource.sql.dbtype;
+
+import org.ametys.runtime.i18n.I18nizableText;
+
+/**
+ * Interface for the SQL database types
+ */
+public interface SQLDatabaseType
+{
+    /**
+     * Get the id of the database type.
+     * @return the id. Can not be null.
+     */
+    public String getId();
+    
+    /**
+     * Get the label of the database type.
+     * @return the label
+     */
+    public I18nizableText getLabel();
+    
+    /**
+     * Get the driver of the database type.
+     * @return the driver. Can not be null.
+     */
+    public String getDriver();
+    
+    /**
+     * Get the url template to use for this database type
+     * @return the url template
+     */
+    public String getTemplate();
+    
+    /**
+     * Get the error message key when the specified driver was not found
+     * @return the error message 
+     */
+    public I18nizableText getDriverNotFoundMessage();
+}
+
Index: main/plugin-core/src/org/ametys/core/datasource/sql/dbtype/SQLDatabaseTypeEnumerator.java
===================================================================
--- main/plugin-core/src/org/ametys/core/datasource/sql/dbtype/SQLDatabaseTypeEnumerator.java	(revision 0)
+++ main/plugin-core/src/org/ametys/core/datasource/sql/dbtype/SQLDatabaseTypeEnumerator.java	(revision 0)
@@ -0,0 +1,53 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.core.datasource.sql.dbtype;
+
+import java.util.Map;
+
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.avalon.framework.service.Serviceable;
+
+import org.ametys.runtime.i18n.I18nizableText;
+import org.ametys.runtime.parameter.Enumerator;
+
+/**
+ * Enumerator for {@link SQLDatabaseType}.
+ */
+public class SQLDatabaseTypeEnumerator implements Enumerator, Serviceable
+{
+    /** The extension point handling the database types */
+    private SQLDatabaseTypeExtensionPoint _sqlDatabaseTypeExtensionPoint;
+    
+    @Override
+    public void service(ServiceManager manager) throws ServiceException
+    {
+        _sqlDatabaseTypeExtensionPoint = (SQLDatabaseTypeExtensionPoint) manager.lookup(SQLDatabaseTypeExtensionPoint.ROLE);
+    }
+    
+    @Override
+    public I18nizableText getEntry(String value) throws Exception
+    {
+        SQLDatabaseType dbType = _sqlDatabaseTypeExtensionPoint.getExtension(value);
+        return dbType != null ? dbType.getLabel() : null;
+    }
+
+    @Override
+    public Map<Object, I18nizableText> getEntries() throws Exception
+    {
+        return _sqlDatabaseTypeExtensionPoint.getSQLDatabaseTypes();
+    }
+}
Index: main/plugin-core/src/org/ametys/core/datasource/sql/dbtype/SQLDatabaseTypeExtensionPoint.java
===================================================================
--- main/plugin-core/src/org/ametys/core/datasource/sql/dbtype/SQLDatabaseTypeExtensionPoint.java	(revision 0)
+++ main/plugin-core/src/org/ametys/core/datasource/sql/dbtype/SQLDatabaseTypeExtensionPoint.java	(revision 0)
@@ -0,0 +1,50 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.core.datasource.sql.dbtype;
+
+import java.util.HashMap;
+import java.util.Map;
+import java.util.Set;
+
+import org.ametys.runtime.i18n.I18nizableText;
+import org.ametys.runtime.plugin.component.AbstractThreadSafeComponentExtensionPoint;
+
+/**
+ * This class is in charge to load and initialize the {@link SQLDatabaseType} 
+ */
+public class SQLDatabaseTypeExtensionPoint extends AbstractThreadSafeComponentExtensionPoint<SQLDatabaseType>
+{
+    /** Avalon Role */
+    public static final String ROLE = SQLDatabaseTypeExtensionPoint.class.getName();
+    
+    /**
+     * Get the SQL database types with their label
+     * @return the SQL database types with their label
+     */
+    public Map<Object, I18nizableText> getSQLDatabaseTypes()
+    {
+        Map<Object, I18nizableText> db = new HashMap<>();
+        
+        Set<String> extensionsIds = getExtensionsIds();
+        for (String extensionId : extensionsIds)
+        {
+            SQLDatabaseType dbType = getExtension(extensionId);
+            db.put(extensionId, dbType.getLabel());
+        }
+        
+        return db;
+    }
+}
